module Getopt
(* A simplified re-implementation of Getopt, a command line parsing tool *)
let noshort='\000'
let nolong=""
type opt = char * string * ((unit -> unit) option) * ((string -> unit) option)

let rec parse opts def ar ix max = 
  if ix > max then ()
  else 
    let arg = ar.(ix) in 
    let argtrim = String.sub arg 2 ((String.length arg) - 2) in
      try 
        let (_, _, a1, a2) =
          List.find (fun (_, option, _, _) -> option=argtrim) opts in
          match a1, a2 with 
              Some f, _ -> f (); parse opts def ar (ix + 1) max
            | _, Some f -> f (ar.(ix + 1)); parse opts def ar (ix + 2) max
      with 
          Not_found -> let _ = def arg in parse opts def ar (ix + 1) max
              
let parse_cmdline opts others =
  parse opts others Sys.argv 1 (Array.length Sys.argv - 1)

