// (c) Microsoft Corporation. All rights reserved

module Microsoft.Fine.Tc

open Absyn
open Tcenv

(* Returns the typ annotated withinfo and the kind synthesized for it *)
val kinding: env -> typ -> (typ * kind)

(* This implements the core source typing from Fine_Typing.v, 
   interleaved with a simple HM type inference algorithm *)
val typing: env -> exp -> (exp * typ * list<bvar<typ>>)
  
(* This is the real external interface. 
   Takes a desugared modul and produces a typed, derefined 
   modul ready to be translated to DMSIL *)
val typing_modul: env -> modul -> option<modul>

