#light "off"
// (c) Microsoft Corporation. All rights reserved

module Microsoft.Fine.Tcutil

open Absyn
exception Err of string
exception Error of string * Range.range

val handleable: exn -> bool
val handle_err: bool -> 'a -> exn -> 'a
val terr: Tcenv.env -> typ -> typ -> Range.range -> 'a
val is_value: exp -> bool
val is_non_variable_value: Tcenv.env -> exp -> bool
(* val kind_equiv: kind -> kind -> bool *)
val kind_dominated: kind -> kind -> bool
val kind_lub: kind -> kind -> kind
val kind_abstractable: kind -> bool

type affines = list<bvar<typ>>
val disjoint_affine_usages: affines -> bool
val subtract: affines -> affines -> affines
val union: affines -> affines -> affines

val lookup_field_in_record_typ: Tcenv.env -> lident -> typ -> typ

val is_implication: typ -> bool
val destruct_implication: typ -> option<typ*typ>
val is_pf_binop: lident -> typ -> bool
val destruct_pf_binop: lident -> typ -> option<typ*typ>
val maybe_eq_proof_typ: typ -> bool
val is_proof_typ_constr: typ -> bool
val is_proof_typ: typ -> bool
val is_tuple_typ: typ -> bool
val typing_const: Tcenv.env -> Sugar.sconst -> typ

val push_tparams: Tcenv.env -> list<tparam> -> Tcenv.env

val get_evidence: exp -> evidence
val get_evidencel: list<exp> -> evidence
val union_ev: evidence -> evidence -> evidence
val subtract_ev_exact: evidence -> evidence -> evidence
val subtract_ev: evidence -> list<exp> -> evidence
(* val ascribe: exp -> typ -> evidence -> exp *)
(* val unascribe: exp -> exp *)
val collect_evidence: exp -> exp

val bot: typ -> exp
val is_closure_typ : Tcenv.env -> typ -> bool
val is_boxed : kind -> bool
val is_xvar_free : bvdef -> typ -> bool
val reflexivity_var : Tcenv.env -> var<typ>
val eqT_of_typ : Tcenv.env -> typ -> typ
val unwrap_pf: typ -> typ
