// (c) Microsoft Corporation. All rights reserved

module Microsoft.Fine.Unionfind

type cell<'a when 'a : not struct> = {mutable contents : contents<'a> }
and contents<'a when 'a : not struct> = 
  | Data of list<'a> * int
  | Fwd of cell<'a>
type uvar<'a when 'a : not struct> = 'a cell

val uvar_id: uvar<'a> -> int
val fresh : 'a -> uvar<'a>
val find : uvar<'a> -> 'a
val change : uvar<'a> -> 'a -> unit
val equivalent : uvar<'a> -> uvar<'a> -> bool
val union : uvar<'a> -> uvar<'a> -> unit

